package euro;

import java.util.List;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import syndicus.domain.util.Euro;
import euro.test.CostWithEuro;
import euro.test.CostWithoutEuro;
import euro.test.GenericDAO;
import euro.test.ServiceLocator;

@RunWith(value = SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:orm-test-context.xml" })
@SuppressWarnings("unchecked")
public class SimpleTest {

	@Test
	public void simpleSaveWO() {
		CostWithoutEuro withoutEuro = new CostWithoutEuro();
		ServiceLocator.getService(GenericDAO.class).persist(withoutEuro);
		final Long id = withoutEuro.getId();
		Assert.assertNotNull(id);
		withoutEuro.setEuro(new Euro(10));
		ServiceLocator.getService(GenericDAO.class).merge(withoutEuro);
		List list = ServiceLocator.getService(GenericDAO.class).getAudits(
				CostWithoutEuro.class);
		Assert.assertEquals(1, list.size());
		withoutEuro = (CostWithoutEuro) list.get(0);
		Assert.assertEquals(new Euro(), withoutEuro.getEuro());
	}

	@Test
	public void simpleSaveW() {
		CostWithEuro withEuro = new CostWithEuro();
		ServiceLocator.getService(GenericDAO.class).persist(withEuro);
		final Long id = withEuro.getId();
		Assert.assertNotNull(id);
		withEuro.setEuro(new Euro(10));
		ServiceLocator.getService(GenericDAO.class).merge(withEuro);
		List list = ServiceLocator.getService(GenericDAO.class).getAudits(
				CostWithEuro.class);
		Assert.assertEquals(1, list.size());
		Assert.assertEquals(1, list.size());
		withEuro = (CostWithEuro) list.get(0);
		Assert.assertEquals(new Euro(), withEuro.getEuro());

	}
}
