package euro.test;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Version;

@MappedSuperclass
public abstract class AbstractBaseEntity implements Serializable, Comparable<AbstractBaseEntity>{

	/** The id. */
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@Column(name = "LastTouched", columnDefinition = "timestamp default CURRENT_TIMESTAMP", nullable = false)
	@Version
	private Timestamp timestamp;

	public Timestamp getTimestamp() {
		return timestamp;
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	@Override
	public int hashCode() {
		return (id == null) ? System.identityHashCode(this) : id.hashCode();
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof AbstractBaseEntity)) {
			return false;
		}
		if(getId()==null){
			return System.identityHashCode(this)==System.identityHashCode(obj);
		}
		AbstractBaseEntity other = (AbstractBaseEntity) obj;
		
		return getId().equals(other.getId());
	}

	public int compareTo(AbstractBaseEntity o) {
		return toString().compareTo(o.toString());
	}

}
