package euro.test;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


/**
 * The Interface GenericDAO.
 */
@Transactional(propagation=Propagation.REQUIRED)
public interface GenericDAO<T extends Serializable, PK extends Serializable>
{
	void persist(Collection<T> costs);

	void persist(T costs);

	/**
	 * refresh
	 * @param instance objet to refresh
	 */
	void refresh(T instance);


	/**
	 * delete
	 * @param persistentInstance objet to delete
	 */
	void delete(T persistentInstance);


	/**
	 * merge
	 * @param detachedInstance objet to merge
	 * @return merged object
	 */
	T merge(T detachedInstance);


	/**
	 * read
	 * @param id of object to read
	 * @return read object
	 */
	T read(PK id);

	Collection<T> findAll();
	
	T getLatestVersion(T t);

	List<T> getAudits(Class<T> t);

}